//
// Copyright (C) 2018-2018 Julien Jahneke <julien.jahneke@ccs-labs.org>
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//

#pragma once

#include <string>
#include <vector>

class PhotoDiode {
public:
    PhotoDiode(std::string m_id, double m_area, double m_gain, std::vector<double> m_spectralResponse)
        : id(m_id)
        , area(m_area)
        , gain(m_gain)
        , spectralResponse(m_spectralResponse){};

    //  ~PhotoDiode();

    double getArea();
    double getGain();
    std::vector<double>& getSpectralResponse();

private:
    std::string id;
    double area;
    double gain;
    std::vector<double> spectralResponse;
};
